<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: modules/tradeShowsModule.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: modules/tradeShowsModule.js</h1>






    <section>
        <article>
            <pre class="prettyprint source linenums"><code>let referenceToThis = null;

/**
 * This function is responsible to set the sales person
 *
 * @param {string} idSalesPerson - Sales person id
 * @param {string} idTradeShow - Trade show id
 * @returns {Promise} Returns a new Promise object.
 */
const setSalesPerson = (idSalesPerson, idTradeShow) => {
  if (idSalesPerson &amp;&amp; idTradeShow) {
    return referenceToThis.tradeShowsSalesPerson.create({
      SalesPerson_idSalesPerson: idSalesPerson,
      TradeShows_idTradeShow: idTradeShow,
    });
  }
  throw new Error(
    'tradeShows.setTradeShow receive two parameters idSalesPerson and idTradeShow please specify them'
  );
};

/**
 * This function is responsible to get the sales person
 *
 * @param {string} idTradeShow - Trade show id
 * @returns {Promise} Returns a new Promise object.
 */
const getSalesPerson = (idTradeShow) => {
  return new Promise((resolve, reject) => {
    referenceToThis.tradeShowsSalesPerson
      .get({
        filter: `TradeShows_idTradeShow=${idTradeShow}`,
      })
      .then((result) => {
        const SalesPersonIds = result.resource.map((item) => {
          return item.SalesPerson_idSalesPerson;
        });

        return referenceToThis.salesPerson
          .get({
            ids: SalesPersonIds.join(','),
          })
          .then((salesPersonResult) => {
            return resolve(salesPersonResult);
          });
      })
      .catch((error) => {
        return reject(error);
      });
  });
};

/**
 * This function is responsible to add products
 *
 * @param {string} idTradeShow - Trade show id
 * @param {string} productIds - Product id
 * @returns {Promise} Returns a new Promise object.
 */
const addProduct = (idTradeShow, productIds) => {
  const itemToAttach = {
    idProduct: productIds,
    idTradeShow,
  };

  return new Promise((resolve, reject) => {
    referenceToThis.tradeShowProducts
      .create(itemToAttach)
      .then((result) => {
        return resolve(result);
      })
      .catch((error) => {
        return reject(error);
      });
  });
};

/**
 * This function is responsible to get products
 *
 * @param {string} idTradeShow - Trade show id
 * @returns {Promise} Returns a new Promise object.
 */
const getProducts = (idTradeShow) => {
  return new Promise((resolve, reject) => {
    referenceToThis.tradeShowProducts
      .get({filter: `idTradeShow=${idTradeShow}`})
      .then((result) => {
        const productIds = result.resource.map((record) => {
          return record.idProduct;
        });

        return referenceToThis.products
          .get({
            ids: productIds,
            related: 'image,category,filter',
          })
          .then((products) => {
            return resolve(products);
          });
      })
      .catch((error) => {
        return reject(error);
      });
  });
};

// const addDocumets = (tradeshowId, fileId) => {
//   const params = {documents: [{id: fileId}]};
//   if (Array.isArray(fileId)) {
//     params.documents = fileId.map((id) => {
//       return {id};
//     });
//   }

//   return referenceToThis.tradeShows.update(tradeshowId, params);
// };

const tradeShowsModule = (thisObject) => {
  referenceToThis = thisObject;
  referenceToThis.tradeShows.addProduct = addProduct;
  referenceToThis.tradeShows.getProducts = getProducts;
  referenceToThis.tradeShows.setSalesPerson = setSalesPerson;
  referenceToThis.tradeShows.getSalesPerson = getSalesPerson;

  // referenceToThis.tradeShows.addDocumets = addDocumets;
};

export default tradeShowsModule;
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Classes</h3><ul><li><a href="HttpClient.html">HttpClient</a></li><li><a href="MagentoClient.html">MagentoClient</a></li></ul><h3>Global</h3><ul><li><a href="global.html#addDocuments">addDocuments</a></li><li><a href="global.html#addProduct">addProduct</a></li><li><a href="global.html#addTags">addTags</a></li><li><a href="global.html#Channels-SDK_Example">Channels-SDK_Example</a></li><li><a href="global.html#Countries-SDK_Example">Countries-SDK_Example</a></li><li><a href="global.html#default">default</a></li><li><a href="global.html#Documents-SDK_Example">Documents-SDK_Example</a></li><li><a href="global.html#filter">filter</a></li><li><a href="global.html#generateEndpointsCrudMethods">generateEndpointsCrudMethods</a></li><li><a href="global.html#getProducts">getProducts</a></li><li><a href="global.html#getSalesPerson">getSalesPerson</a></li><li><a href="global.html#getTradeShows">getTradeShows</a></li><li><a href="global.html#importAndExecuteModules">importAndExecuteModules</a></li><li><a href="global.html#ProductCategories-SDK_Example">ProductCategories-SDK_Example</a></li><li><a href="global.html#Products-SDK_Example">Products-SDK_Example</a></li><li><a href="global.html#Recipes-SDK_Example">Recipes-SDK_Example</a></li><li><a href="global.html#removeTags">removeTags</a></li><li><a href="global.html#retrieveRecipes">retrieveRecipes</a></li><li><a href="global.html#SalesPerson-SDK_Example">SalesPerson-SDK_Example</a></li><li><a href="global.html#salesPersonModule">salesPersonModule</a></li><li><a href="global.html#SalesRepresentative-SDK_Example">SalesRepresentative-SDK_Example</a></li><li><a href="global.html#Samples-SDK_Example">Samples-SDK_Example</a></li><li><a href="global.html#setSalesPerson">setSalesPerson</a></li><li><a href="global.html#setTradeShow">setTradeShow</a></li><li><a href="global.html#synchronize">synchronize</a></li><li><a href="global.html#Tags-SDK_Example">Tags-SDK_Example</a></li><li><a href="global.html#Tradeshow-SDK_Example">Tradeshow-SDK_Example</a></li><li><a href="global.html#UserTypes-SDK_Example">UserTypes-SDK_Example</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.3</a> on Fri Nov 22 2019 13:09:48 GMT-0600 (Central Standard Time)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
